// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package Freeze;

public class Catalog extends Freeze.MapInternal.MapI<java.lang.String, Freeze.CatalogData>
{
    private
    Catalog(Freeze.Connection __connection, String __dbName, java.util.Comparator<java.lang.String> __comparator)
    {
        super(__connection, __dbName, __comparator);
    }

    /**
     * Instantiates a Freeze map using the given connection. If the database
     * named in <code>__dbName</code> does not exist and <code>__createDb</code>
     * is true, the database is created automatically, otherwise this constructor
     * raises <code>DatabaseException</code>.
     * @param __connection The Freeze connection associated with this map.
     * @param __dbName The name of the Berkeley DB database.
     * @param __createDb True if the database should be created if it does not
     *   already exist, false otherwise.
     * @param __comparator A comparator for the map's main key, or null to use the
     *   default key comparison strategy.
     * @throws Freeze.DatabaseException If an error occurs during database operations.
     */
    public
    Catalog(Freeze.Connection __connection, String __dbName, boolean __createDb, java.util.Comparator<java.lang.String> __comparator)
    {
        super(__connection,  __dbName, "string", "::Freeze::CatalogData", __createDb, __comparator);
    }

    /**
     * Instantiates a Freeze map using the given connection. If the database
     * named in <code>__dbName</code> does not exist and <code>__createDb</code>
     * is true, the database is created automatically, otherwise this constructor
     * raises <code>DatabaseException</code>. The map uses the default key
     * comparison strategy.
     * @param __connection The Freeze connection associated with this map.
     * @param __dbName The name of the Berkeley DB database.
     * @param __createDb True if the database should be created if it does not
     *   already exist, false otherwise.
     * @throws Freeze.DatabaseException If an error occurs during database operations.
     */
    public
    Catalog(Freeze.Connection __connection, String __dbName, boolean __createDb)
    {
        this(__connection, __dbName, __createDb, null);
    }

    /**
     * Instantiates a Freeze map using the given connection. If the database
     * named in <code>__dbName</code> does not exist, it is created automatically.
     * The map uses the default key comparison strategy.
     * @param __connection The Freeze connection associated with this map.
     * @param __dbName The name of the Berkeley DB database.
     * @throws Freeze.DatabaseException If an error occurs during database operations.
     */
    public
    Catalog(Freeze.Connection __connection, String __dbName)
    {
        this(__connection, __dbName, true);
    }

    /**
     * Copies an existing database. The new database has the name given in
     * <code>__dbName</code>, and the old database is renamed with a UUID
     * suffix.
     * @param __connection The Freeze connection associated with this map.
     * @param __dbName The name of the Berkeley DB database.
     * @param __comparator A comparator for the map's main key, or null to use the
     *   default key comparison strategy.
     * @throws Freeze.DatabaseException If an error occurs during database operations.
     */
    public static void
    recreate(Freeze.Connection __connection, String __dbName, java.util.Comparator<java.lang.String> __comparator)
    {
        Catalog __tmpMap = new Catalog(__connection, __dbName, __comparator);
        recreate(__tmpMap, __dbName, "string", "::Freeze::CatalogData", null);
    }

    public byte[]
    encodeKey(java.lang.String v, Ice.Communicator communicator, Ice.EncodingVersion encoding)
    {
        IceInternal.BasicStream __os = new IceInternal.BasicStream(IceInternal.Util.getInstance(communicator), encoding, true, false);
        __os.writeString(v);
        IceInternal.Buffer __buf = __os.prepareWrite();
        byte[] __r = new byte[__buf.size()];
        __buf.b.get(__r);
        return __r;
    }

    public java.lang.String
    decodeKey(byte[] b, Ice.Communicator communicator, Ice.EncodingVersion encoding)
    {
        IceInternal.BasicStream __is = new IceInternal.BasicStream(IceInternal.Util.getInstance(communicator), encoding, b);
        java.lang.String __r;
        __r = __is.readString();
        return __r;
    }

    public byte[]
    encodeValue(Freeze.CatalogData v, Ice.Communicator communicator, Ice.EncodingVersion encoding)
    {
        IceInternal.BasicStream __os = new IceInternal.BasicStream(IceInternal.Util.getInstance(communicator), encoding, true, false);
        __os.startWriteEncaps();
        v.__write(__os);
        __os.endWriteEncaps();
        IceInternal.Buffer __buf = __os.prepareWrite();
        byte[] __r = new byte[__buf.size()];
        __buf.b.get(__r);
        return __r;
    }

    public Freeze.CatalogData
    decodeValue(byte[] b, Ice.Communicator communicator, Ice.EncodingVersion encoding)
    {
        IceInternal.BasicStream __is = new IceInternal.BasicStream(IceInternal.Util.getInstance(communicator), encoding, b);
        __is.startReadEncaps();
        Freeze.CatalogData __r;
        __r = new Freeze.CatalogData();
        __r.__read(__is);
        __is.endReadEncaps();
        return __r;
    }
}
